# Get DrawingWindow
from soar.widgets import *

import __builtin__    

import GridWorld
reload(GridWorld)
from GridWorld import *

import Planner
reload(Planner)
from Planner import *

import Bus
reload(Bus)
from Bus import *

import XYDriver
reload(XYDriver)
from XYDriver import *

import TSMFull
reload(TSMFull)
from TSMFull import *

# For knowing our exactly location, in the simulator only
def cheatPose():
    return app.soar.output.abspose.get()    

def drawUsAndBusPlan(gw, robotLocs, busLocs, times, w, windowWidth):
    w.clear()
    gw.drawWorld(w, windowWidth)    
    for (robotLoc, busLoc, time) in zip(robotLocs, busLocs, times):
        if robotLoc == busLoc:
            gw.drawState(robotLoc, w, windowWidth,
                         "green", label = str(time))
        else:
            gw.drawState(robotLoc, w, windowWidth,
                         "pink", label = str(time))
            gw.drawState(busLoc, w, windowWidth,
                         "yellow", label = str(time))

# Where the bus is, when
# Think of the bus as taking big steps
timeAtStop = 4.0 # sec
busV = 0.8 # m / sec      # bus much faster than robot
# The bus stops in this world are two meters apart
distBetweenStops = 2.0 # m
timeBetweenStops = distBetweenStops / busV  # sec
timePerRoute = 4 * (timeAtStop + timeBetweenStops)
def busSchedule(time):
    # schedule goes around in 4 * (timeAtStop + timeBetweenStops)
    t = time % timePerRoute
    if t < timeAtStop:
        return (5, 5)
    elif t < timeAtStop + timeBetweenStops:
        return None
    elif t < 2*timeAtStop + timeBetweenStops:
        return (15, 5)
    elif t < 2*timeAtStop + 2*timeBetweenStops:
        return None
    elif t < 3*timeAtStop + 2*timeBetweenStops:
        return (15, 15)
    elif t < 3*timeAtStop + 3*timeBetweenStops:
        return None
    elif t < 4*timeAtStop + 3*timeBetweenStops:
        return (5, 15)
    else:
        return None


######################################################################
###
###          Brain methods
###
######################################################################

(xmin, xmax, ymin, ymax) = (0.0, 4.0, 0.0, 4.0)
(windowWidth, windowHeight) = (400, 400)
gridN = 20
goalEpsilon = (xmax - xmin) / (5 * gridN)

# Just a guess.  Steps have high variance.  1.0 is pretty good.
timePerRobotStep = 1.0
    
def setup():
    # Your code location 1

    # Procedure that will plan a path and execute the first step
    def dynamicReplanner():
        # Your code location 2
        # plan =

        if plan and len(plan) > 1:
            # Code location 3.  Your expressions instead of the xxx's below
            drawUsAndBusPlan(gw, XXX, XXX, XXX, w, windowWidth)
            # Return a terminating behavior to take the first action
            motion = gw.indicesToPose(plan[1] xxxxx)
            if motion == (0.0, 0.0):
                return Wait(5)
            else:
                return XYDriverOA(motion, goalEpsilon)
        elif len(plan) == 1:            #  successful plan of length 1
            print 'Woohoo, caught the bus!'
            return Wait(5)
        else:                           # failure, no plan
            print 'No way to catch the bus!'
            return Wait(5)
        
    # A really disgusting hack to synchronize watches between the
    # bus simulator and the robot.
    robot.t = __builtin__.robotTime

    # Make the stream of behaviors and start it going
    robot.driver = StreamTSM(dynamicReplanner)
    robot.driver.start(collectSensors())

def step():
    robot.t = __builtin__.robotTime
    doAction(robot.driver.step(collectSensors()))
    motorOutput(fvel, rvel)

def collectSensors():
    return [sonarDistances(), cheatPose()]

def doAction(a):
    (fvel, rvel) = a
    motorOutput(fvel, rvel)


